<?php

namespace Slovocast\Middleware;

use Odan\Session\SessionManagerInterface;
use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Server\RequestHandlerInterface as RequestHandler;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;

/**
 * Start a session on every single request, regardless. There may be a reason
 * to never start a session but I highly doubt it.
 */
class SessionMiddleware implements MiddlewareInterface
{
    public function __construct(
        private SessionManagerInterface $sessionManager
    ) { }

    public function process(Request $request, RequestHandler $handler): Response
    {
        if (!$this->sessionManager->isStarted()) {
            $this->sessionManager->start();
        }
    
        return $handler->handle($request);
    }
}
